﻿using DemoCommon.Grid;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Enums;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Dynamic;
using System.Windows.Forms;

namespace AddNewRow
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            DataTable dt = new DataTable();
            dt.Columns.Add("Id", typeof(int));
            dt.Columns.Add("Selected", typeof(bool));
            dt.Rows.Add(new object[] { 1, false });
            dt.Rows.Add(new object[] { 2, true });
            dt.Rows.Add(new object[] { 3, false });
            dt.Rows.Add(new object[] { 4, true });
            dt.Rows.Add(new object[] { 5, false });
            dt.Rows.Add(new object[] { 1, false });
            dt.Rows.Add(new object[] { 2, true });
            dt.Rows.Add(new object[] { 3, false });
            dt.Rows.Add(new object[] { 4, true });
            dt.Rows.Add(new object[] { 5, false });
            List<dynamic> dynamicDt = dt.ToDynamic();
            sfDataGrid.DataSource = dynamicDt;
            sfDataGrid1.DataSource = dynamicDt;
        }
    }

    public static class HelperExtensions
    {
        public static List<dynamic> ToDynamic(this DataTable dt)
        {
            var dynamicDt = new List<dynamic>();
            foreach (System.Data.DataRow row in dt.Rows)
            {
                dynamic dyn = new ExpandoObject();
                dynamicDt.Add(dyn);
                foreach (DataColumn column in dt.Columns)
                {
                    var dic = (IDictionary<string, object>)dyn;
                    dic[column.ColumnName] = row[column];
                }
            }
            return dynamicDt;
        }
    }

}
